#include <Adafruit_Fingerprint.h>
#define SENSOR_TX_PIN 4
#define SENSOR_RX_PIN 3
#define SENSOR_TOUCH_PIN 2
#define RED_LED_PIN 9
#define GREEN_LED_PIN 8

SoftwareSerial sensorSerial(SENSOR_TX_PIN, SENSOR_RX_PIN);
Adafruit_Fingerprint finger = Adafruit_Fingerprint(&sensorSerial);

int greenLed = LOW;

void setup() {
  pinMode(SENSOR_TOUCH_PIN, INPUT);
  pinMode(RED_LED_PIN, OUTPUT);
  pinMode(GREEN_LED_PIN, OUTPUT);
  finger.begin(57600);
  delay(100);
  if (!finger.verifyPassword()) {
    digitalWrite(RED_LED_PIN, HIGH);
    while (true);
  }
}

void loop() {
  while (!digitalRead(SENSOR_TOUCH_PIN));
  if (scanFingerprint(1) != FINGERPRINT_OK) {
    error();
    return;
  }

  if (finger.fingerSearch() != FINGERPRINT_OK) {
    error();
    return;
  }

  greenLed = !greenLed;
  digitalWrite(GREEN_LED_PIN, greenLed);
  while (digitalRead(SENSOR_TOUCH_PIN));
  delay(200);
}

void error() {
  for (int i = 0; i < 3; i++) {
    digitalWrite(RED_LED_PIN, HIGH);
    delay(100);
    digitalWrite(RED_LED_PIN, LOW);
    delay(100);
  }
  while (digitalRead(SENSOR_TOUCH_PIN));
  delay(200);
}

uint8_t scanFingerprint(uint8_t slot) {
  uint8_t status;
  
  do {
    status = finger.getImage();
  } while (status == FINGERPRINT_NOFINGER);

  if (status != FINGERPRINT_OK) {
    return status;
  }

  return finger.image2Tz(slot);
}